
'Fuer die geeignete Stimmung sorgen versch. Sounds:

Local snowmusic:TSound = LoadSound("sounds/snowmusic.ogg")
Local churchbells:TSound = LoadSound("sounds/churchbells.ogg")


'Als erstes wird eine einfache, aber wirkungsvolle Schneeflocke "hergestellt":

SetColor 64,64,64
DrawRect 0,4,9,1
DrawRect 4,0,1,9
DrawLine 1,1,8,8
DrawLine 8,1,1,8
TSnowFlake.image = GrabAlphaImage(9,9)
For Local i% = 0 To scx*scy / 10000
	Local z# = 0.25 + 0.75 * i / (scx*scy / 10000.0)
	TSnowFlake.Create(z*z)
Next

'Im Folgenden sieht man die Schneeflockenklasse inklusive ihrer verwaltenden Liste:

Type TSnowFlake

	Global image:TImage, time%
	Global list:TList = CreateList()
	Field x%, y#, z#, a#, r%, r_plus%
	
	Function Create(z#)
		Local NewSnowFlake:TSnowFlake = New TSnowFlake
		NewSnowFlake.x = Rand(0, scx)
		NewSnowFlake.y = Rand(-scy, 0)
		NewSnowFlake.z = z
		NewSnowFlake.a = 0.3 + 0.7*NewSnowFlake.z
		NewSnowFlake.r = Rand(0,359)
		NewSnowFlake.r_plus = Rand(2,6) * (1-2*Rand(0,1))
		ListAddLast(list, NewSnowFlake)	
	End Function
	
	'statt neue zu erzeugen, werden jene Flocken, die am Bildschirmrand angekommen sind, neu gestartet:
	
	Method restart()
		x = Rand(0, scx)
		y = -0.01*scy
	End Method
	
	Method draw_only()
		SetScale z, z
		SetAlpha a
		SetRotation r
		DrawImage image, x, y
	End Method
	
	Method draw_and_move@()
		SetScale z, z
		SetAlpha a
		SetRotation r
		DrawImage image, x, y
		r = r + r_plus
		y = y + 5*z
		If y > scy Then Return True
	End Method
	
	Function drawAll(new_time%)
	
		'alle 50 Millisekunden bewegen sich alle Flocken:
	
		If new_time - time > 50 Then 
			For Local SnowFlake:TSnowFlake = EachIn list
				If SnowFlake.draw_and_move() = True Then Snowflake.restart()		
			Next
			time = new_time
			
		'ansonsten werden sie nur gemalt:
			
		Else
			For Local SnowFlake:TSnowFlake = EachIn list
				SnowFlake.draw_only()	
			Next
		End If
		SetScale 1,1
		SetAlpha 1
		SetRotation 0
	End Function
	
End Type
'###########################################
