SuperStrict

	'manche Linux-Distributionen scheinen leider diese Zusatzkonfiguration zu benoetigen:
	?Linux
	Local success@ = EnableOpenALAudio()
	If success = True Then success = SetAudioDriver("OpenAL")
	If success = False Then
		Local drivers$[] = AudioDrivers()
		For Local d% = 0 Until Len(drivers)
			If AudioDriverExists(drivers[d]) Then success = SetAudioDriver(drivers[d])	
			If success = True Then Exit
		Next
	End If
	?

SeedRnd(MilliSecs())
Global timer:TTimer = CreateTimer(60)
Global scx% = DesktopWidth()
Global scy% = DesktopHeight()
Graphics scx, scy, DesktopDepth()
SetBlend ALPHABLEND
HideMouse()
Flip
AutoMidHandle(True)

Include "functions.bmx"
Include "fire.bmx"
Include "snowflake.bmx"
Include "background.bmx"


'###############################
'In den folgenden Hauptschleifen nun die kleine "story" des Films:
'###############################

'Nahe bei den stillen Haeusern stehen:
'###############################
Local distance_scale# = 4
Local memo_time% = MilliSecs()
SetScale distance_scale, distance_scale
Repeat
	If KeyHit(KEY_ESCAPE) > 0 Or AppTerminate() = True Then End
	Local actual_time% = MilliSecs()
	If actual_time - memo_time > 3000 Then Exit
	DrawImage Background, 0.54*scx, 0.85*scy - 0.1*scy + Sin(9600)*0.01*scy
	SetScale distance_scale * 0.75, distance_scale * 0.75
	DrawImage Village_front, 0.54*scx, 0.85*scy - 0.1*scy + Sin(9600)*0.01*scy
	SetScale distance_scale, distance_scale
	Flip
	WaitTimer(timer)
Forever
PlaySound(LoadSound("sounds/snow-footsteps.ogg"))
'###############################
'Sich vom Dorf entfernen:
'###############################
memo_time = MilliSecs()
Repeat
	Local actual_time% = MilliSecs()
	Local going_value# = 1-(actual_time - memo_time) / 20000.0
	If going_value =< 0 Then Exit
	distance_scale = 3*going_value*going_value+1	
	SetOrigin 0, going_value*Sin(going_value*9600)*0.005*scy
	DrawImage Background, 0.54*scx, 0.85*scy - going_value * 0.1*scy
	If KeyHit(KEY_ESCAPE) > 0 Or AppTerminate() = True Then End
	SetScale distance_scale * 0.75, distance_scale * 0.75
	DrawImage Village_front, 0.54*scx, 0.85*scy - going_value * 0.1*scy
	SetScale distance_scale, distance_scale
	Flip
	WaitTimer(timer)
	distance_scale = Max(1.0, distance_scale - 0.01)
Forever
SetOrigin 0, 0
'###############################
PlaySound(snowmusic)
'Einsetzender Schneefall:
'###############################
memo_time% = MilliSecs()
Local pause_duration% = 20000
Repeat
	Local actual_time% = MilliSecs()
	DrawImage Background, 0.54*scx, 0.85*scy
	If KeyHit(KEY_ESCAPE) > 0 Or AppTerminate() = True Then End
	If actual_time - memo_time > pause_duration Then
		memo_time = actual_time
		pause_duration = 4150
		Exit
	End If
	SetColor 255,255,255
	SetScale 0.75, 0.75
	DrawImage Village_front, 0.54*scx, 0.85*scy
	'===================================
	TSnowFlake.drawAll(actual_time)
	'===================================
	Flip
	WaitTimer(timer)
Forever
'###############################
'Beginnendes Feuerwerk:
Repeat
	Local actual_time% = MilliSecs()
	DrawImage Background, 0.54*scx, 0.85*scy
	If KeyHit(KEY_ESCAPE) > 0 Or AppTerminate() = True Then End
	'===================================
	If actual_time - memo_time > pause_duration Then
		Tfirework.Create(actual_time)
		memo_time = actual_time
		pause_duration:-150
		If pause_duration <= 250 Then Exit
	End If
	Tfirework.ControlAll(actual_time)
	'===================================
	SetColor 255,255,255
	SetScale 0.75, 0.75
	DrawImage Village_front, 0.54*scx, 0.85*scy
	'===================================
	TSnowFlake.drawAll(actual_time)
	'===================================
	Flip
	WaitTimer(timer)
Forever
'###############################
'Neujahr:
PlaySound(churchbells)
Repeat
	Local actual_time% = MilliSecs()
	DrawImage Background, 0.54*scx, 0.85*scy
	If KeyHit(KEY_ESCAPE) > 0 Or AppTerminate() = True Then End
	'===================================
	If actual_time - memo_time > pause_duration Then
		Tfirework.Create(actual_time)
		memo_time = actual_time
	End If
	Tfirework.ControlAll(actual_time)
	'===================================
	SetColor 255,255,255
	SetScale 0.75, 0.75
	DrawImage Village_front, 0.54*scx, 0.85*scy
	'===================================
	TSnowFlake.drawAll(actual_time)
	'===================================
	Flip
	WaitTimer(timer)
Forever
'###############################
'wenn das Feuerwerk nicht unterbrochen wird, geht es ewig weiter...